<?php

namespace app\components;

use Yii;

use yii\db\Query;
use yii\base\BaseObject;
use yii\helpers\VarDumper;
use yii\httpclient\Client;
use yii\httpclient\Exception;
use app\models\Paiement;

class PaiementRetrieverJob extends BaseObject implements \yii\queue\JobInterface
{
    /**
    * @var int $recordId id de l'enregistrement correspondant au paiement
    */
    public $remoteId;

    public function execute($queue)
    {
      Yii::debug('PaiementRetrieverJob was called, with remoteId = '.$this->remoteId, __METHOD__);
      $client = new Client();
      $response_retrieve = $client->createRequest()
          ->setMethod('GET')
          ->setUrl(MPAY_API_BASE_URL.'/paiements/'.$this->remoteId)
          ->addHeaders(['Authorization' => 'Basic ' . base64_encode(API_ACCESS_KEY . ':')])
          ->send();
      if ($response_retrieve->isOk) {
          $fields=array();
          foreach ((new Paiement())->attributes as $fieldname => $fieldvalue) {
            $fields[$fieldname] = $response_retrieve->data[$fieldname];
          }
          $paiement= new Paiement($fields);
          //on efface l'id reçu du serveur afin que notre base génère le sien au moment
          //de l'enregistrement
          $paiement->id=null;
          if ($paiement->save()) {
              //On met le statut à OK.
              //TODO Vérifier que l'opération a abouti
              $response_statut = $client->createRequest()
                  ->setMethod('POST')
                  ->setUrl(MPAY_API_BASE_URL.'/paiement/statut')
                  ->setData(['id' => $this->remoteId, 'statut' => 'OK'])
                  ->addHeaders(['Authorization' => 'Basic ' . base64_encode(API_ACCESS_KEY . ':')])
                  ->send();
              if($response_statut->isOk) {
                if(defined(SERVICE_RETURN_URL)) {
                    $url = SERVICE_RETURN_URL;
                    $url=str_replace('%ID%', $paiement->id, $url);
                    $url=str_replace('%TRANSACTION_ID%', $paiement->transaction_id, $url);
                    $url=str_replace('%AMOUNT%', $paiement->amount, $url);
                    $response_notif = $client->head($url)->send();
                    if(!$response_notif->isOK) {
                        Yii::warning('L\'url de rappel n\'a pas pu être appelée; Le paiement avait pour ID local: '. $paiement->id, __METHOD__);
                    }
                }
              } else {
                  Yii::warning('Le paiement ID = '. $remoteId . ' n\'a pas pu être mis à OK sur les serveurs MPay.', __METHOD__);
              }
          } else {
              Yii::warning('Le paiement ID = '. $remoteId . ' n\'a pas pu être sauvagardé.', __METHOD__);
          }
        } else {
            Yii::warning('Le information du paiement ID = '. $remoteId . ' n\'ont pas pu être rapatriées.');
        }
    }
}
