<?php

namespace app\migrations;

use yii\db\Migration;
use app\models\Paiement;
/**
 * Class m190712_000947_creation_table_paiement
 */
class m190712_000947_creation_table_paiement extends Migration
{
    /**
     * {@inheritdoc}
     */
    public function safeUp()
    {
      $this->createTable(Paiement::tableName(), [
          '[[id]]' => $this->primaryKey(),
          '[[type]]' => $this->string(30)->notNull(),
          '[[transaction_id]]' => $this->string(50)->null(),
          '[[amount]]' => $this->integer()->null(),
          '[[amount_debit]]' => $this->integer()->null(),
          '[[statut]]' => $this->string(7)->notNull()->defaultValue('Pending'),
          '[[date]]' => $this->datetime()->null(),
          '[[last_modified]]' => $this->datetime()->null(),
          '[[creation_date]]' => $this->datetime()->null(),
          '[[reseau]]' => $this->string(20)->null(),
          '[[original_sms]]' => $this->string(255)->null(),
          '[[original_timestamp]]' => $this->integer()->null(),
          '[[original_sender]]' => $this->string(20)->null(),
          '[[nom_expediteur]]' => $this->string(150)->null(),
          '[[numero_destinataire]]' => $this->string(20)->null(),
          '[[nom_destinataire]]' => $this->string(150)->null(),
          '[[solde]]' => $this->integer()->null(),
      ]);
      $this->createIndex('key_transaction_id', Paiement::tableName(), ['[[transaction_id]]',
        '[[reseau]]', '[[type]]', ],true);
      $this->createIndex('ndx_amount', Paiement::tableName(), ['[[amount]]']);
      $this->createIndex('ndx_statut', Paiement::tableName(), ['[[statut]]']);
      $this->createIndex('ndx_reseau', Paiement::tableName(), ['[[reseau]]']);
      $this->createIndex('ndx_date', Paiement::tableName(), ['[[date]]']);
      $this->createIndex('ndx_last_modified', Paiement::tableName(), ['[[last_modified]]']);
      $this->createIndex('ndx_original_sender', Paiement::tableName(), ['[[original_sender]]']);
      $this->createIndex('ndx_nom_expediteur', Paiement::tableName(), ['[[nom_expediteur]]']);
      $this->createIndex('ndx_creation_date', Paiement::tableName(), ['[[creation_date]]']);
      $this->createIndex('ndx_amount_debit', Paiement::tableName(), ['[[amount_debit]]']);
      $this->createIndex('ndx_numero_destinataire', Paiement::tableName(), ['[[numero_destinataire]]']);
      $this->createIndex('ndx_nom_destinataire', Paiement::tableName(), ['[[nom_destinataire]]']);
      $this->createIndex('ndx_type', Paiement::tableName(), ['[[type]]']);
      $this->execute('ALTER TABLE '.Paiement::tableName() .' ADD INDEX `ndx_original_sms` (`original_sms`(191))');
      $this->createIndex('ndx_solde', Paiement::tableName(), ['[[solde]]']);

    }

    /**
     * {@inheritdoc}
     */
    public function safeDown()
    {
        $this->dropTable(Paiement::tableName());
        return true;
    }

    /*
    // Use up()/down() to run migration code without a transaction.
    public function up()
    {

    }

    public function down()
    {
        echo "m190712_000947_creation_table_paiement cannot be reverted.\n";

        return false;
    }
    */
}
